/// <reference types="amap-js-api" />
import { IMapService, IViewport, IMapCamera } from '@antv/l7-core';
import 'reflect-metadata';
import { IAMapEvent, IAMapInstance } from '../../typings/index';
import AMapBaseService from '../utils/amap/AMapBaseService';
/**
 * AMapService
 */
export default class AMapService extends AMapBaseService implements IMapService<AMap.Map & IAMapInstance> {
    version: string;
    protected viewport: IViewport;
    getModelMatrix(lnglat: [number, number], altitude: number, rotate: [number, number, number], scale?: [number, number, number]): number[];
    init(): Promise<void>;
    meterToCoord(center: [number, number], outer: [number, number]): number;
    updateView(viewOption: Partial<IMapCamera>): void;
    getOverlayContainer(): HTMLElement | undefined;
    exportMap(type: 'jpg' | 'png'): string;
    onCameraChanged(callback: (viewport: IViewport) => void): void;
    protected handleCameraChanged: (e: IAMapEvent) => void;
}
