/**
 * MapboxService
 */
import { IEarthService, IMercator, IViewport } from '@antv/l7-core';
import { Map } from '@antv/l7-map';
import 'reflect-metadata';
import Viewport from './Viewport';
import BaseMapService from '../utils/BaseMapService';
/**
 * EarthService
 */
export default class L7EarthService extends BaseMapService<Map> implements IEarthService {
    lngLatToMercator(lnglat: [number, number], altitude: number): IMercator;
    getModelMatrix(lnglat: [number, number], altitude: number, rotate: [number, number, number], scale: [number, number, number], origin: IMercator): number[];
    version: string;
    dragging: boolean;
    viewport: Viewport;
    protected cameraChangedCallback: (viewport: IViewport) => void;
    private handleCameraChanging;
    private handleCameraTimer;
    on(type: string, handle: (...args: any[]) => void): void;
    off(type: string, handle: (...args: any[]) => void): void;
    getMapCanvasContainer(): HTMLElement;
    getSize(): [number, number];
    getType(): string;
    init(): Promise<void>;
    destroy(): void;
    emit(name: string, ...args: any[]): void;
    once(name: string, ...args: any[]): void;
    getMapContainer(): HTMLElement | null;
    onCameraChanged(callback: (viewport: IViewport) => void): void;
    /**
     * 地球模式向外暴露的 Y 轴旋转方法
     * @returns
     */
    rotateY(option: {
        force: boolean;
        reg: number;
    }): void;
    protected handleCameraChanged: (e: any) => void;
}
