/**
 * MapboxService
 */
import { IMercator } from '@antv/l7-core';
import { Map } from '@antv/l7-map';
import 'reflect-metadata';
import Viewport from '../utils/Viewport';
import BaseMapService from '../utils/BaseMapService';
/**
 * AMapService
 */
export default class L7MapService extends BaseMapService<Map> {
    version: string;
    lngLatToMercator(_lnglat: [number, number], _altitude: number): IMercator;
    getModelMatrix(): number[];
    viewport: Viewport;
    init(): Promise<void>;
    initMiniMap(): Promise<void>;
    exportMap(type: 'jpg' | 'png'): string;
    private handleMiniCameraChanged;
}
