/**
 * MapboxService
 */
import { IMercator } from '@antv/l7-core';
import { Map } from 'mapbox-gl';
import 'mapbox-gl/dist/mapbox-gl.css';
import 'reflect-metadata';
import { IMapboxInstance } from '../../typings/index';
import Viewport from './Viewport';
import BaseMapService from '../utils/BaseMapService';
/**
 * AMapService
 */
export default class MapboxService extends BaseMapService<Map & IMapboxInstance> {
    version: string;
    viewport: Viewport;
    getType(): string;
    /**
     * 将经纬度转成墨卡托坐标
     * @param lnglat
     * @returns
     */
    lngLatToCoord(lnglat: [number, number], origin?: IMercator): [number, number];
    lngLatToMercator(lnglat: [number, number], altitude: number): IMercator;
    getModelMatrix(lnglat: [number, number], altitude: number, rotate: [number, number, number], scale?: [number, number, number], origin?: IMercator): number[];
    init(): Promise<void>;
    destroy(): void;
    emit(name: string, ...args: any[]): void;
    once(name: string, ...args: any[]): void;
    getMapContainer(): HTMLElement | null;
    meterToCoord(center: [number, number], outer: [number, number]): number;
    exportMap(type: 'jpg' | 'png'): string;
    protected creatMapContainer(id: string | HTMLDivElement): HTMLDivElement;
}
