export interface ISimpleMapCoord {
    setSize(size: number): void;
    getSize(): [number, number];
    project(lnglat: [number, number]): [number, number];
    unproject(xy: [number, number]): [number, number];
}
export declare class SimpleMapCoord implements ISimpleMapCoord {
    private size;
    constructor(size?: number);
    setSize(size: number): void;
    getSize(): [number, number];
    /**
     * coord
     * ^ y (y > 0)
     * |
     * |
     * |
     * |(x = 0, y = 0)
     * ---------------> x (x > 0)
     */
    /***
     * lng: [-180, 180] 360
     * lat: [-85.05112877980659, 85.05112877980659] 170.10225755961318
     */
    mercatorXfromLng(lng: number): number;
    mercatorYfromLat(lat: number): number;
    lngFromMercatorX(x: number): number;
    latFromMercatorY(y: number): number;
    project(lnglat: [number, number]): [number, number];
    unproject(xy: [number, number]): [number, number];
}
