var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/amap/map.ts
var map_exports = {};
__export(map_exports, {
  default: () => AMapService
});
module.exports = __toCommonJS(map_exports);
var import_amap_jsapi_loader = __toESM(require("@amap/amap-jsapi-loader"));
var import_l7_core = require("@antv/l7-core");
var import_gl_matrix = require("gl-matrix");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_version = require("../version");
var import_Viewport = __toESM(require("./Viewport"));
var import_AMapBaseService = __toESM(require("../utils/amap/AMapBaseService"));
window.forceWebGL = true;
var AMAP_API_KEY = "15cd8a57710d40c9b7c0e3cc120f1200";
var AMAP_VERSION = "1.4.15";
var amapLoaded = false;
var pendingResolveQueue = [];
var LNGLAT_OFFSET_ZOOM_THRESHOLD = 12;
var AMapService = class extends import_AMapBaseService.default {
  constructor() {
    super(...arguments);
    this.version = import_version.Version["GAODE1.x"];
    this.handleCameraChanged = (e) => {
      const {
        fov,
        near,
        far,
        height,
        pitch,
        rotation,
        aspect,
        position
      } = e.camera;
      const { lng, lat } = this.getCenter();
      this.emit("mapchange");
      if (this.cameraChangedCallback) {
        this.viewport.syncWithMapCamera({
          aspect,
          bearing: 360 - rotation,
          far,
          fov,
          cameraHeight: height,
          near,
          pitch,
          zoom: this.map.getZoom() - 1,
          center: [lng, lat],
          offsetOrigin: [position.x, position.y]
        });
        const { offsetZoom = LNGLAT_OFFSET_ZOOM_THRESHOLD } = this.config;
        if (this.viewport.getZoom() > offsetZoom) {
          this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20_OFFSET);
        } else {
          this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20);
        }
        this.cameraChangedCallback(this.viewport);
      }
    };
  }
  getModelMatrix(lnglat, altitude, rotate, scale = [1, 1, 1]) {
    const flat = this.viewport.projectFlat(lnglat);
    const modelMatrix = import_gl_matrix.mat4.create();
    import_gl_matrix.mat4.translate(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(flat[0], flat[1], altitude));
    import_gl_matrix.mat4.scale(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(scale[0], scale[1], scale[2]));
    import_gl_matrix.mat4.rotateX(modelMatrix, modelMatrix, rotate[0]);
    import_gl_matrix.mat4.rotateY(modelMatrix, modelMatrix, rotate[1]);
    import_gl_matrix.mat4.rotateZ(modelMatrix, modelMatrix, rotate[2]);
    return modelMatrix;
  }
  async init() {
    const {
      id,
      style = "light",
      minZoom = 0,
      maxZoom = 18,
      token = AMAP_API_KEY,
      mapInstance,
      plugin = [],
      ...rest
    } = this.config;
    await new Promise((resolve) => {
      const resolveMap = () => {
        if (mapInstance) {
          this.map = mapInstance;
          this.$mapContainer = this.map.getContainer();
          setTimeout(() => {
            this.map.on("camerachange", this.handleCameraChanged);
            resolve();
          }, 30);
        } else {
          this.$mapContainer = this.creatMapContainer(id);
          const mapConstructorOptions = {
            mapStyle: this.getMapStyle(style),
            zooms: [minZoom, maxZoom],
            viewMode: "3D",
            ...rest
          };
          if (mapConstructorOptions.zoom) {
            mapConstructorOptions.zoom += 1;
          }
          const map = new AMap.Map(this.$mapContainer, mapConstructorOptions);
          map.on("camerachange", this.handleCameraChanged);
          map.on("camerachange", () => {
            setTimeout(() => this.handleAfterMapChange());
          });
          this.map = map;
          setTimeout(() => {
            resolve();
          }, 10);
        }
      };
      if (!amapLoaded && !mapInstance) {
        if (token === AMAP_API_KEY) {
          console.warn(this.configService.getSceneWarninfo("MapToken"));
        }
        amapLoaded = true;
        plugin.push("Map3D");
        import_amap_jsapi_loader.default.load({
          key: token,
          version: AMAP_VERSION,
          plugins: plugin
        }).then((AMap2) => {
          resolveMap();
          if (pendingResolveQueue.length) {
            pendingResolveQueue.forEach((r) => r());
            pendingResolveQueue = [];
          }
        }).catch((e) => {
          throw new Error(e);
        });
      } else {
        if (amapLoaded && window.AMap || mapInstance) {
          resolveMap();
        } else {
          pendingResolveQueue.push(resolveMap);
        }
      }
    });
    this.viewport = new import_Viewport.default();
  }
  meterToCoord(center, outer) {
    const meterDis = AMap.GeometryUtil.distance(new AMap.LngLat(...center), new AMap.LngLat(...outer));
    const [x1, y1] = this.lngLatToCoord(center);
    const [x2, y2] = this.lngLatToCoord(outer);
    const coordDis = Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2));
    return coordDis / meterDis;
  }
  updateView(viewOption) {
  }
  getOverlayContainer() {
    return void 0;
  }
  exportMap(type) {
    var _a;
    const renderCanvas = (_a = this.getContainer()) == null ? void 0 : _a.getElementsByClassName("amap-layer")[0];
    const layersPng = type === "jpg" ? renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/jpeg") : renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/png");
    return layersPng;
  }
  onCameraChanged(callback) {
    this.cameraChangedCallback = callback;
  }
};
AMapService = __decorateClass([
  (0, import_inversify.injectable)()
], AMapService);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
