var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/amap2/Viewport.ts
var Viewport_exports = {};
__export(Viewport_exports, {
  default: () => Viewport
});
module.exports = __toCommonJS(Viewport_exports);
var import_gl_matrix = require("gl-matrix");
var Viewport = class {
  constructor() {
    this.projectionMatrix = import_gl_matrix.mat4.create();
    this.viewMatrix = import_gl_matrix.mat4.create();
    this.viewProjectionMatrix = import_gl_matrix.mat4.create();
    this.ViewProjectionMatrixUncentered = import_gl_matrix.mat4.create();
    this.viewUncenteredMatrix = import_gl_matrix.mat4.create();
  }
  syncWithMapCamera(mapCamera) {
    const {
      zoom = 1,
      center = [0, 0],
      offsetOrigin = [0, 0],
      cameraPosition = [0, 0, 0],
      up = [0, 1, 0],
      lookAt = [0, 0, 0],
      aspect = 1,
      near = 0.1,
      far = 1e3,
      fov = 45
    } = mapCamera;
    this.zoom = zoom;
    this.center = center;
    import_gl_matrix.mat4.perspective(this.projectionMatrix, fov / 180 * Math.PI, aspect, near, far);
    const eyePoint = import_gl_matrix.vec3.fromValues(...cameraPosition);
    const lookAtPoint = import_gl_matrix.vec3.fromValues(...lookAt);
    const upDirect = import_gl_matrix.vec3.fromValues(...up);
    import_gl_matrix.mat4.lookAt(this.viewMatrix, eyePoint, lookAtPoint, upDirect);
    this.viewUncenteredMatrix = import_gl_matrix.mat4.clone(this.viewMatrix);
    import_gl_matrix.mat4.translate(this.viewMatrix, this.viewMatrix, import_gl_matrix.vec3.fromValues(-offsetOrigin[0], offsetOrigin[1], 0));
    import_gl_matrix.mat4.multiply(this.viewProjectionMatrix, this.projectionMatrix, this.viewMatrix);
    import_gl_matrix.mat4.multiply(this.ViewProjectionMatrixUncentered, this.projectionMatrix, this.viewMatrix);
  }
  getZoom() {
    return this.zoom;
  }
  getZoomScale() {
    return 1048576;
  }
  getCenter() {
    const [lng, lat] = this.center;
    return [lng, lat];
  }
  getProjectionMatrix() {
    return this.projectionMatrix;
  }
  getModelMatrix() {
    return [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
  }
  getViewMatrix() {
    return this.viewMatrix;
  }
  getViewMatrixUncentered() {
    return this.viewUncenteredMatrix;
  }
  getViewProjectionMatrix() {
    return this.viewProjectionMatrix;
  }
  getViewProjectionMatrixUncentered() {
    return this.ViewProjectionMatrixUncentered;
  }
  getFocalDistance() {
    return 1;
  }
  projectFlat(lngLat, scale) {
    const maxs = 85.0511287798;
    const lat = Math.max(Math.min(maxs, lngLat[1]), -maxs);
    const zoomScale = 256 << 20;
    let d = Math.PI / 180;
    let x = lngLat[0] * d;
    let y = lat * d;
    y = Math.log(Math.tan(Math.PI / 4 + y / 2));
    const a = 0.5 / Math.PI;
    const b = 0.5;
    const c = -0.5 / Math.PI;
    d = 0.5;
    x = zoomScale * (a * x + b) - 215440491;
    y = -(zoomScale * (c * y + d) - 106744817);
    return [x, y];
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
