var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/amap2/map.ts
var map_exports = {};
__export(map_exports, {
  default: () => AMapService
});
module.exports = __toCommonJS(map_exports);
var import_amap_jsapi_loader = __toESM(require("@amap/amap-jsapi-loader"));
var import_l7_core = require("@antv/l7-core");
var import_l7_utils = require("@antv/l7-utils");
var import_gl_matrix = require("gl-matrix");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_version = require("../version");
var import_logo = require("./logo.css");
var import_theme = require("./theme");
var import_Viewport = __toESM(require("./Viewport"));
var import_AMapBaseService = __toESM(require("../utils/amap/AMapBaseService"));
window.forceWebGL = true;
var AMAP_API_KEY = "ff533602d57df6f8ab3b0fea226ae52f";
var AMAP_VERSION = "2.0.5";
var amapLoaded = false;
var pendingResolveQueue = [];
var AMapService = class extends import_AMapBaseService.default {
  constructor() {
    super(...arguments);
    this.version = import_version.Version["GAODE2.x"];
    this.handleViewChanged = (e) => {
      const {
        fov,
        near,
        far,
        aspect,
        position,
        lookAt,
        up
      } = this.map.customCoords.getCameraParams();
      this.emit("mapchange");
      const center = this.map.customCoords.getCenter();
      if (this.cameraChangedCallback) {
        this.viewport.syncWithMapCamera({
          aspect,
          far,
          fov,
          cameraPosition: position,
          lookAt,
          up,
          near,
          zoom: this.map.getZoom() - 1,
          center,
          offsetOrigin: [position[0], position[1]]
        });
        this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20_2);
        this.cameraChangedCallback(this.viewport);
      }
    };
  }
  setCustomCoordCenter(center) {
    this.sceneCenter = center;
    this.sceneCenterMKT = (0, import_l7_utils.amap2Project)(...center);
  }
  getCustomCoordCenter() {
    return this.sceneCenterMKT;
  }
  lngLatToCoordByLayer(lnglat, layerCenter) {
    const layerCenterFlat = (0, import_l7_utils.amap2Project)(...layerCenter);
    return this._sub((0, import_l7_utils.amap2Project)(lnglat[0], lnglat[1]), layerCenterFlat);
  }
  lngLatToCoordsByLayer(lnglatArray, layerCenter) {
    return lnglatArray.map((lnglats) => {
      if (typeof lnglats[0] === "number") {
        return this.lngLatToCoordByLayer(lnglats, layerCenter);
      } else {
        return lnglats.map((lnglat) => {
          return this.lngLatToCoordByLayer(lnglat, layerCenter);
        });
      }
    });
  }
  lngLatToCoord(lnglat) {
    if (!this.sceneCenter) {
      this.map.customCoords.setCenter(lnglat);
      this.setCustomCoordCenter(lnglat);
    }
    return this._sub((0, import_l7_utils.amap2Project)(lnglat[0], lnglat[1]), this.sceneCenterMKT);
  }
  lngLatToCoords(lnglatArray) {
    return lnglatArray.map((lnglats) => {
      if (typeof lnglats[0] === "number") {
        return this.lngLatToCoord(lnglats);
      } else {
        return lnglats.map((lnglat) => {
          return this.lngLatToCoord(lnglat);
        });
      }
    });
  }
  addMarkerContainer() {
    if (!this.map) {
      return;
    }
    const mapContainer = this.map.getContainer();
    if (mapContainer !== null) {
      const amap = mapContainer.getElementsByClassName("amap-maps")[0];
      amap.style.zIndex = "auto";
      this.markerContainer = import_l7_utils.DOM.create("div", "l7-marker-container2", amap);
    }
  }
  updateView(_viewOption) {
  }
  getOverlayContainer() {
    return void 0;
  }
  getMapStyle(name) {
    return import_theme.MapTheme[name] ? import_theme.MapTheme[name] : name;
  }
  getType() {
    return "amap2";
  }
  getBounds() {
    const bounds = this.map.getBounds();
    const NE = bounds.getNorthEast();
    const SW = bounds.getSouthWest();
    const center = this.getCenter();
    const maxlng = center.lng > NE.getLng() || center.lng < SW.getLng() ? 180 - NE.getLng() : NE.getLng();
    const minlng = center.lng < SW.getLng() ? SW.getLng() - 180 : SW.getLng();
    return [
      [minlng, SW.getLat()],
      [maxlng, NE.getLat()]
    ];
  }
  getMinZoom() {
    const zooms = this.map.getZooms();
    return zooms[0] - 1;
  }
  getMaxZoom() {
    const zooms = this.map.getZooms();
    return zooms[1] - 1;
  }
  lngLatToContainer(lnglat) {
    const pixel = this.map.lngLatToContainer(lnglat);
    return {
      x: pixel.getX(),
      y: pixel.getY()
    };
  }
  getModelMatrix(lnglat, altitude, rotate, scale = [1, 1, 1]) {
    const flat = this.map.customCoords.lngLatToCoord(lnglat);
    const modelMatrix = import_gl_matrix.mat4.create();
    import_gl_matrix.mat4.translate(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(flat[0], flat[1], altitude));
    import_gl_matrix.mat4.scale(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(scale[0], scale[1], scale[2]));
    import_gl_matrix.mat4.rotateX(modelMatrix, modelMatrix, rotate[0]);
    import_gl_matrix.mat4.rotateY(modelMatrix, modelMatrix, rotate[1]);
    import_gl_matrix.mat4.rotateZ(modelMatrix, modelMatrix, rotate[2]);
    return modelMatrix;
  }
  async init() {
    const {
      id,
      style = "light",
      minZoom = 0,
      maxZoom = 18,
      token = AMAP_API_KEY,
      mapInstance,
      plugin = [],
      version = AMAP_VERSION,
      ...rest
    } = this.config;
    await new Promise((resolve) => {
      const resolveMap = () => {
        var _a;
        if (mapInstance) {
          this.map = mapInstance;
          this.$mapContainer = this.map.getContainer();
          const mapInitCenter = this.map.getCenter();
          (_a = this.map.customCoords) == null ? void 0 : _a.setCenter([
            mapInitCenter.lng,
            mapInitCenter.lat
          ]);
          this.setCustomCoordCenter([mapInitCenter.lng, mapInitCenter.lat]);
          setTimeout(() => {
            this.map.on("viewchange", this.handleViewChanged);
            resolve();
          }, 30);
        } else {
          this.$mapContainer = this.creatMapContainer(id);
          const mapConstructorOptions = {
            mapStyle: this.getMapStyle(style),
            zooms: [minZoom, maxZoom],
            viewMode: "3D",
            ...rest
          };
          if (mapConstructorOptions.zoom) {
            mapConstructorOptions.zoom += 1;
          }
          const map = new AMap.Map(this.$mapContainer, mapConstructorOptions);
          this.map = map;
          const mapInitCenter = map.getCenter();
          map.customCoords.setCenter([mapInitCenter.lng, mapInitCenter.lat]);
          this.setCustomCoordCenter([mapInitCenter.lng, mapInitCenter.lat]);
          map.on("viewchange", this.handleViewChanged);
          setTimeout(() => {
            resolve();
          }, 10);
        }
      };
      this.viewport = new import_Viewport.default();
      if (!amapLoaded && !mapInstance) {
        if (token === AMAP_API_KEY) {
          console.warn(this.configService.getSceneWarninfo("MapToken"));
        }
        amapLoaded = true;
        plugin.push("Map3D");
        import_amap_jsapi_loader.default.load({
          key: token,
          version: AMAP_VERSION,
          plugins: plugin
        }).then((AMap2) => {
          resolveMap();
          if (pendingResolveQueue.length) {
            pendingResolveQueue.forEach((r) => r());
            pendingResolveQueue = [];
          }
        }).catch((e) => {
          throw new Error(e);
        });
      } else {
        if (amapLoaded && window.AMap || mapInstance) {
          resolveMap();
        } else {
          pendingResolveQueue.push(resolveMap);
        }
      }
    });
    this.initViewPort();
  }
  getMapContainer() {
    return this.$mapContainer;
  }
  onCameraChanged(callback) {
    this.cameraChangedCallback = callback;
  }
  initViewPort() {
    var _a;
    const {
      fov,
      near,
      far,
      aspect,
      position,
      lookAt,
      up
    } = (_a = this.map.customCoords) == null ? void 0 : _a.getCameraParams();
    this.emit("mapchange");
    const center = this.map.customCoords.getCenter();
    const zoom = this.map.getZoom();
    if (this.cameraChangedCallback) {
      this.viewport.syncWithMapCamera({
        aspect,
        far,
        fov,
        cameraPosition: position,
        lookAt,
        near,
        up,
        zoom: zoom - 1,
        center,
        offsetOrigin: [position[0], position[1]]
      });
      this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20_2);
      this.cameraChangedCallback(this.viewport);
    }
  }
  _sub(a, b) {
    const r = [0, 0];
    r[0] = a[0] - b[0];
    r[1] = a[1] - b[1];
    return r;
  }
};
AMapService = __decorateClass([
  (0, import_inversify.injectable)()
], AMapService);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
