var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/earth/Viewport.ts
var Viewport_exports = {};
__export(Viewport_exports, {
  default: () => Viewport
});
module.exports = __toCommonJS(Viewport_exports);
var import_gl_matrix = require("gl-matrix");
var Viewport = class {
  constructor() {
    this.xzReg = -Math.PI * 0.6;
    this.yReg = Math.PI * 0.2;
    this.earthCameraRadius = 200;
    this.earthCameraZoom = 1;
    this.cameraPosition = import_gl_matrix.vec3.create();
    this.projectionMatrix = import_gl_matrix.mat4.create();
    this.modelMatrix = import_gl_matrix.mat4.create();
    this.viewMatrix = import_gl_matrix.mat4.create();
    this.viewProjectionMatrix = import_gl_matrix.mat4.create();
    this.ViewProjectionMatrixUncentered = import_gl_matrix.mat4.create();
    this.viewUncenteredMatrix = import_gl_matrix.mat4.create();
  }
  syncWithMapCamera(mapCamera) {
    const { viewportHeight = 1, viewportWidth = 1 } = mapCamera;
    const aspect = viewportWidth / viewportHeight;
    const near = 0.1;
    const far = 1e4;
    const fov = 20;
    import_gl_matrix.mat4.perspective(this.projectionMatrix, fov, aspect, near, far);
    const x = this.earthCameraRadius * Math.cos(this.xzReg);
    const z = this.earthCameraRadius * Math.sin(this.xzReg);
    const y = this.earthCameraRadius * Math.sin(this.yReg);
    this.cameraPosition = import_gl_matrix.vec3.fromValues(x, y, z);
    import_gl_matrix.vec3.normalize(this.cameraPosition, this.cameraPosition);
    import_gl_matrix.vec3.multiply(this.cameraPosition, this.cameraPosition, import_gl_matrix.vec3.fromValues(this.earthCameraRadius, this.earthCameraRadius, this.earthCameraRadius));
    import_gl_matrix.vec3.scale(this.cameraPosition, this.cameraPosition, this.earthCameraZoom);
    const crossY = import_gl_matrix.vec3.create();
    import_gl_matrix.vec3.cross(crossY, this.cameraPosition, import_gl_matrix.vec3.fromValues(0, 1, 0));
    const up = import_gl_matrix.vec3.fromValues(0, 1, 0);
    import_gl_matrix.vec3.cross(up, crossY, this.cameraPosition);
    const target = import_gl_matrix.vec3.fromValues(0, 0, 0);
    import_gl_matrix.mat4.lookAt(this.viewMatrix, this.cameraPosition, target, up);
    this.viewUncenteredMatrix = import_gl_matrix.mat4.clone(this.viewMatrix);
    import_gl_matrix.mat4.multiply(this.viewProjectionMatrix, this.projectionMatrix, this.viewMatrix);
    import_gl_matrix.mat4.multiply(this.ViewProjectionMatrixUncentered, this.projectionMatrix, this.viewMatrix);
  }
  rotateY(r) {
    this.xzReg += r * Math.min(this.earthCameraZoom * this.earthCameraZoom, 1);
  }
  rotateX(r) {
    this.yReg += r * Math.min(this.earthCameraZoom * this.earthCameraZoom, 1);
  }
  scaleZoom(z) {
    this.earthCameraZoom += z;
    this.earthCameraZoom = Math.max(this.earthCameraZoom, 0.6);
  }
  getZoom() {
    return 4;
  }
  getZoomScale() {
    return Math.pow(2, this.getZoom());
  }
  getCenter() {
    return [0, 0];
  }
  getProjectionMatrix() {
    return this.projectionMatrix;
  }
  getModelMatrix() {
    return this.modelMatrix;
  }
  getViewMatrix() {
    return this.viewMatrix;
  }
  getViewMatrixUncentered() {
    return this.viewMatrix;
  }
  getViewProjectionMatrix() {
    return this.viewProjectionMatrix;
  }
  getViewProjectionMatrixUncentered() {
    return this.viewProjectionMatrix;
  }
  getFocalDistance() {
    return 1;
  }
  projectFlat(lngLat, scale) {
    return this.viewport.projectFlat(lngLat, scale);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
