var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/map/map.ts
var map_exports = {};
__export(map_exports, {
  default: () => L7MapService
});
module.exports = __toCommonJS(map_exports);
var import_l7_core = require("@antv/l7-core");
var import_l7_map = require("@antv/l7-map");
var import_l7_utils = require("@antv/l7-utils");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_version = require("../version");
var import_Viewport = __toESM(require("../utils/Viewport"));
var import_BaseMapService = __toESM(require("../utils/BaseMapService"));
var LNGLAT_OFFSET_ZOOM_THRESHOLD = 12;
var L7MapService = class extends import_BaseMapService.default {
  constructor() {
    super(...arguments);
    this.version = import_version.Version.L7MAP;
    this.handleMiniCameraChanged = (lng, lat, zoom, bearing, pitch) => {
      const { offsetCoordinate = true } = this.config;
      this.viewport.syncWithMapCamera({
        bearing,
        center: [lng, lat],
        viewportHeight: this.map.transform.height,
        pitch,
        viewportWidth: this.map.transform.width,
        zoom,
        cameraHeight: 0
      });
      if (this.viewport.getZoom() > LNGLAT_OFFSET_ZOOM_THRESHOLD && offsetCoordinate) {
        this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.LNGLAT_OFFSET);
      } else {
        this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.LNGLAT);
      }
      this.cameraChangedCallback(this.viewport);
    };
  }
  lngLatToMercator(_lnglat, _altitude) {
    throw new Error("Method not implemented.");
  }
  getModelMatrix() {
    throw new Error("Method not implemented.");
  }
  async init() {
    const {
      id = "map",
      style = "light",
      rotation = 0,
      mapInstance,
      version = "L7MAP",
      mapSize = 1e4,
      interactive = true,
      ...rest
    } = this.config;
    this.viewport = new import_Viewport.default();
    this.version = version;
    this.simpleMapCoord.setSize(mapSize);
    if (version === import_version.Version.SIMPLE && rest.center) {
      rest.center = this.simpleMapCoord.unproject(rest.center);
    }
    if (mapInstance) {
      this.map = mapInstance;
      this.$mapContainer = this.map.getContainer();
    } else {
      this.$mapContainer = this.creatMapContainer(id);
      this.map = new import_l7_map.Map({
        container: this.$mapContainer,
        style: this.getMapStyle(style),
        bearing: rotation,
        ...rest
      });
    }
    this.map.on("load", this.handleCameraChanged);
    if (interactive) {
      this.map.on("move", this.handleCameraChanged);
    }
    this.handleCameraChanged();
  }
  async initMiniMap() {
    const {
      id = "map",
      style = "light",
      rotation = 0,
      mapInstance,
      canvas = null,
      hasBaseMap = false,
      ...rest
    } = this.config;
    this.viewport = new import_Viewport.default();
    this.$mapContainer = canvas;
    this.map = new import_l7_map.Map({
      container: this.$mapContainer,
      style: this.getMapStyle(style),
      bearing: rotation,
      canvas,
      ...rest
    });
    if (!hasBaseMap) {
      this.map.on("load", this.handleCameraChanged);
      this.map.on("move", this.handleCameraChanged);
      this.handleCameraChanged();
    } else {
      const center = this.map.getCenter();
      this.handleMiniCameraChanged(center.lng, center.lat, this.map.getZoom(), this.map.getBearing(), this.map.getPitch());
      import_l7_utils.$window.document.addEventListener("mapCameaParams", (event) => {
        const {
          e: { longitude, latitude, scale, bearing, pitch }
        } = event;
        this.handleMiniCameraChanged(longitude, latitude, scale - 1.25, bearing, pitch);
      });
    }
  }
  exportMap(type) {
    const renderCanvas = this.map.getCanvas();
    const layersPng = type === "jpg" ? renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/jpeg") : renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/png");
    return layersPng;
  }
};
L7MapService = __decorateClass([
  (0, import_inversify.injectable)()
], L7MapService);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
