var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/utils/amap/AMapBaseService.ts
var AMapBaseService_exports = {};
__export(AMapBaseService_exports, {
  default: () => AMapBaseService
});
module.exports = __toCommonJS(AMapBaseService_exports);
var import_amap_jsapi_loader = __toESM(require("@amap/amap-jsapi-loader"));
var import_l7_core = require("@antv/l7-core");
var import_l7_utils = require("@antv/l7-utils");
var import_gl_matrix = require("gl-matrix");
var import_inversify = require("inversify");
var import_reflect_metadata = require("reflect-metadata");
var import_simpleMapCoord = require("../simpleMapCoord");
var import_utils = require("../utils");
var import_version = require("../../version");
var import_Viewport = __toESM(require("../Viewport"));
var import_logo = require("./logo.css");
var import_theme = require("./theme");
var mapdivCount = 0;
window.forceWebGL = true;
var AMAP_API_KEY = "15cd8a57710d40c9b7c0e3cc120f1200";
var AMAP_VERSION = "1.4.15";
var AMAP_SCRIPT_ID = "amap-script";
var amapLoaded = false;
var pendingResolveQueue = [];
var LNGLAT_OFFSET_ZOOM_THRESHOLD = 12;
var AMapBaseService = class {
  constructor() {
    this.version = import_version.Version["GAODE1.x"];
    this.simpleMapCoord = new import_simpleMapCoord.SimpleMapCoord();
    this.bgColor = "rgba(0, 0, 0, 0)";
    this.handleCameraChanged = (e) => {
      const {
        fov,
        near,
        far,
        height,
        pitch,
        rotation,
        aspect,
        position
      } = e.camera;
      const { lng, lat } = this.getCenter();
      this.emit("mapchange");
      if (this.cameraChangedCallback) {
        this.viewport.syncWithMapCamera({
          aspect,
          bearing: 360 - rotation,
          far,
          fov,
          cameraHeight: height,
          near,
          pitch,
          zoom: this.map.getZoom() - 1,
          center: [lng, lat],
          offsetOrigin: [position.x, position.y]
        });
        const { offsetZoom = LNGLAT_OFFSET_ZOOM_THRESHOLD } = this.config;
        if (this.viewport.getZoom() > offsetZoom) {
          this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20_OFFSET);
        } else {
          this.coordinateSystemService.setCoordinateSystem(import_l7_core.CoordinateSystem.P20);
        }
        this.cameraChangedCallback(this.viewport);
      }
    };
  }
  setBgColor(color) {
    this.bgColor = color;
  }
  addMarkerContainer() {
    const mapContainer = this.map.getContainer();
    if (mapContainer !== null) {
      const amap = mapContainer.getElementsByClassName("amap-maps")[0];
      this.markerContainer = import_l7_utils.DOM.create("div", "l7-marker-container", amap);
    }
  }
  getMarkerContainer() {
    return this.markerContainer;
  }
  on(type, handler) {
    if (import_l7_core.MapServiceEvent.indexOf(type) !== -1) {
      this.eventEmitter.on(type, handler);
    } else {
      this.map.on(type, handler);
    }
  }
  off(type, handler) {
    if (import_l7_core.MapServiceEvent.indexOf(type) !== -1) {
      this.eventEmitter.off(type, handler);
    } else {
      this.map.off(type, handler);
    }
  }
  getContainer() {
    return this.map.getContainer();
  }
  getMapCanvasContainer() {
    var _a;
    return (_a = this.map.getContainer()) == null ? void 0 : _a.getElementsByClassName("amap-maps")[0];
  }
  getSize() {
    const size = this.map.getSize();
    return [size.getWidth(), size.getHeight()];
  }
  getType() {
    return "amap";
  }
  getZoom() {
    return this.map.getZoom() - 1;
  }
  setZoom(zoom) {
    return this.map.setZoom(zoom + 1);
  }
  getCenter(options) {
    if (options == null ? void 0 : options.padding) {
      const originCenter = this.getCenter();
      const [w, h] = this.getSize();
      const padding = (0, import_utils.toPaddingOptions)(options.padding);
      const px = this.lngLatToPixel([originCenter.lng, originCenter.lat]);
      const offsetPx = [
        (padding.right - padding.left) / 2,
        (padding.bottom - padding.top) / 2
      ];
      const newCenter = this.pixelToLngLat([
        px.x - offsetPx[0],
        px.y - offsetPx[1]
      ]);
      return newCenter;
    }
    const center = this.map.getCenter();
    return {
      lng: center.getLng(),
      lat: center.getLat()
    };
  }
  setCenter(lnglat, options) {
    if (options == null ? void 0 : options.padding) {
      const padding = (0, import_utils.toPaddingOptions)(options.padding);
      const px = this.lngLatToPixel(lnglat);
      const offsetPx = [
        (padding.right - padding.left) / 2,
        (padding.bottom - padding.top) / 2
      ];
      const newCenter = this.pixelToLngLat([
        px.x + offsetPx[0],
        px.y + offsetPx[1]
      ]);
      this.map.setCenter([newCenter.lng, newCenter.lat]);
    } else {
      this.map.setCenter(lnglat);
    }
  }
  getPitch() {
    return this.map.getPitch();
  }
  getRotation() {
    return 360 - this.map.getRotation();
  }
  getBounds() {
    const amapBound = this.map.getBounds().toBounds();
    const NE = amapBound.getNorthEast();
    const SW = amapBound.getSouthWest();
    const center = this.getCenter();
    const maxlng = center.lng > NE.getLng() || center.lng < SW.getLng() ? 180 - NE.getLng() : NE.getLng();
    const minlng = center.lng < SW.getLng() ? SW.getLng() - 180 : SW.getLng();
    return [
      [minlng, SW.getLat()],
      [maxlng, NE.getLat()]
    ];
  }
  getMinZoom() {
    const zooms = this.map.get("zooms");
    return zooms[0] - 1;
  }
  getMaxZoom() {
    const zooms = this.map.get("zooms");
    return zooms[1] - 1;
  }
  setRotation(rotation) {
    return this.map.setRotation(rotation);
  }
  setPitch(pitch) {
    return this.map.setPitch(pitch);
  }
  zoomIn() {
    this.map.zoomIn();
  }
  zoomOut() {
    this.map.zoomOut();
  }
  panTo(p) {
    this.map.panTo(p);
  }
  panBy(x = 0, y = 0) {
    this.map.panBy(x, y);
  }
  fitBounds(extent) {
    this.map.setBounds(new AMap.Bounds([extent[0][0], extent[0][1], extent[1][0], extent[1][1]]));
  }
  setZoomAndCenter(zoom, center) {
    this.map.setZoomAndCenter(zoom + 1, center);
  }
  setMapStyle(style) {
    this.map.setMapStyle(this.getMapStyle(style));
  }
  setMapStatus(option) {
    this.map.setStatus(option);
  }
  pixelToLngLat(pixel) {
    const lngLat = this.map.pixelToLngLat(new AMap.Pixel(pixel[0], pixel[1]));
    return { lng: lngLat.getLng(), lat: lngLat.getLat() };
  }
  lngLatToPixel(lnglat) {
    const p = this.map.lnglatToPixel(new AMap.LngLat(lnglat[0], lnglat[1]));
    return {
      x: p.getX(),
      y: p.getY()
    };
  }
  containerToLngLat(pixel) {
    const ll = new AMap.Pixel(pixel[0], pixel[1]);
    const lngLat = this.map.containerToLngLat(ll);
    return {
      lng: lngLat == null ? void 0 : lngLat.getLng(),
      lat: lngLat == null ? void 0 : lngLat.getLat()
    };
  }
  lngLatToContainer(lnglat) {
    const ll = new AMap.LngLat(lnglat[0], lnglat[1]);
    const pixel = this.map.lngLatToContainer(ll);
    return {
      x: pixel.getX(),
      y: pixel.getY()
    };
  }
  lngLatToCoord(lnglat) {
    const { x, y } = this.map.lngLatToGeodeticCoord(lnglat);
    return [x, -y];
  }
  lngLatToMercator(lnglat, altitude) {
    return {
      x: 0,
      y: 0,
      z: 0
    };
  }
  getModelMatrix(lnglat, altitude, rotate, scale = [1, 1, 1]) {
    const flat = this.viewport.projectFlat(lnglat);
    const modelMatrix = import_gl_matrix.mat4.create();
    import_gl_matrix.mat4.translate(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(flat[0], flat[1], altitude));
    import_gl_matrix.mat4.scale(modelMatrix, modelMatrix, import_gl_matrix.vec3.fromValues(scale[0], scale[1], scale[2]));
    import_gl_matrix.mat4.rotateX(modelMatrix, modelMatrix, rotate[0]);
    import_gl_matrix.mat4.rotateY(modelMatrix, modelMatrix, rotate[1]);
    import_gl_matrix.mat4.rotateZ(modelMatrix, modelMatrix, rotate[2]);
    return modelMatrix;
  }
  async init() {
    const {
      id,
      style = "light",
      minZoom = 0,
      maxZoom = 18,
      token = AMAP_API_KEY,
      mapInstance,
      plugin = [],
      ...rest
    } = this.config;
    await new Promise((resolve) => {
      const resolveMap = () => {
        if (mapInstance) {
          this.map = mapInstance;
          this.$mapContainer = this.map.getContainer();
          setTimeout(() => {
            this.map.on("camerachange", this.handleCameraChanged);
            resolve();
          }, 30);
        } else {
          this.$mapContainer = this.creatMapContainer(id);
          const mapConstructorOptions = {
            mapStyle: this.getMapStyle(style),
            zooms: [minZoom, maxZoom],
            viewMode: "3D",
            ...rest
          };
          if (mapConstructorOptions.zoom) {
            mapConstructorOptions.zoom += 1;
          }
          const map = new AMap.Map(this.$mapContainer, mapConstructorOptions);
          map.on("camerachange", this.handleCameraChanged);
          map.on("camerachange", () => {
            setTimeout(() => this.handleAfterMapChange());
          });
          this.map = map;
          setTimeout(() => {
            resolve();
          }, 10);
        }
      };
      if (!amapLoaded && !mapInstance) {
        if (token === AMAP_API_KEY) {
          console.warn(this.configService.getSceneWarninfo("MapToken"));
        }
        amapLoaded = true;
        plugin.push("Map3D");
        import_amap_jsapi_loader.default.load({
          key: token,
          version: AMAP_VERSION,
          plugins: plugin
        }).then((AMap2) => {
          resolveMap();
          if (pendingResolveQueue.length) {
            pendingResolveQueue.forEach((r) => r());
            pendingResolveQueue = [];
          }
        }).catch((e) => {
          throw new Error(e);
        });
      } else {
        if (amapLoaded && window.AMap || mapInstance) {
          resolveMap();
        } else {
          pendingResolveQueue.push(resolveMap);
        }
      }
    });
    this.viewport = new import_Viewport.default();
  }
  meterToCoord(center, outer) {
    const meterDis = AMap.GeometryUtil.distance(new AMap.LngLat(...center), new AMap.LngLat(...outer));
    const [x1, y1] = this.lngLatToCoord(center);
    const [x2, y2] = this.lngLatToCoord(outer);
    const coordDis = Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2));
    return coordDis / meterDis;
  }
  updateView(viewOption) {
  }
  getOverlayContainer() {
    return void 0;
  }
  exportMap(type) {
    var _a;
    const renderCanvas = (_a = this.getContainer()) == null ? void 0 : _a.getElementsByClassName("amap-layer")[0];
    const layersPng = type === "jpg" ? renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/jpeg") : renderCanvas == null ? void 0 : renderCanvas.toDataURL("image/png");
    return layersPng;
  }
  emit(name, ...args) {
    this.eventEmitter.emit(name, ...args);
  }
  once(name, ...args) {
    this.eventEmitter.once(name, ...args);
  }
  destroy() {
    var _a, _b;
    this.map.destroy();
    (_b = (_a = this.$mapContainer) == null ? void 0 : _a.parentNode) == null ? void 0 : _b.removeChild(this.$mapContainer);
    delete window.initAMap;
    const $jsapi = document.getElementById(AMAP_SCRIPT_ID);
    if ($jsapi) {
      document.head.removeChild($jsapi);
    }
  }
  getMapContainer() {
    return this.$mapContainer;
  }
  onCameraChanged(callback) {
    this.cameraChangedCallback = callback;
  }
  handleAfterMapChange() {
    this.emit("mapAfterFrameChange");
  }
  getMapStyle(name) {
    return import_theme.MapTheme[name] ? import_theme.MapTheme[name] : name;
  }
  creatMapContainer(id) {
    let $wrapper = id;
    if (typeof id === "string") {
      $wrapper = document.getElementById(id);
    }
    const $amapdiv = document.createElement("div");
    $amapdiv.style.cssText += `
       position: absolute;
       top: 0;
       height: 100%;
       width: 100%;
     `;
    $amapdiv.id = "l7_amap_div" + mapdivCount++;
    $wrapper.appendChild($amapdiv);
    return $amapdiv;
  }
};
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IGlobalConfigService)
], AMapBaseService.prototype, "configService", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.MapConfig)
], AMapBaseService.prototype, "config", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.ICoordinateSystemService)
], AMapBaseService.prototype, "coordinateSystemService", 2);
__decorateClass([
  (0, import_inversify.inject)(import_l7_core.TYPES.IEventEmitter)
], AMapBaseService.prototype, "eventEmitter", 2);
AMapBaseService = __decorateClass([
  (0, import_inversify.injectable)()
], AMapBaseService);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
